; Elink GUI support file.             G.Burke 10/2006
 
.386
.model flat, stdcall
option casemap :none
      
;eANSI
;eIMPORT c:\windows\system32\kernel32.dll
;eIMPORT c:\windows\system32\user32.dll
;eIMPORT c:\windows\system32\comdlg32.dll

;-- always a handy macro....
m2m MACRO m1, m2
    push m2
    pop  m1
ENDM

NULL                    equ 0h
WM_DESTROY              equ 2h
BM_GETCHECK             equ 0F0h
BM_SETCHECK             equ 0F1h
WM_COMMAND              equ 111h

OFN_FLAGS               equ 000A0C04h
CREATE_FLAGS            equ 1F0FFFh

.code
    call_eu             dd      0

MSG_STRUCT: ; Windows Message Structure
    MSGhWnd             dd      0
    MSGmessage          dd      0
    MSGwParam           dd      0
    MSGlParam           dd      0
    MSGtime             dd      0
    MSGptX              dd      0
    MSBptY              dd      0

RECT_STRUCT: ; Windows Rectangle Structure
    RECTleft            dd      0
    RECTtop             dd      0
    RECTright           dd      0
    RECTbottom          dd      0
    
OPENFILENAME_STRUCT: ; Open Dialog Structure
    OFNlStructSize      dd      4Ch
    OFNhwndOwner        dd      0
    OFNhInstance        dd      0
    OFNlpstrFilter      dd      0
    OFNlpstrCustFilter  dd      0
    OFNnMaxCustFilter   dd      0
    OFNnFilterIndex     dd      0
    OFNlpstrFile        dd      0
    OFNnMaxFile         dd      0
    OFNlpstrFileTitle   dd      0
    OFNnMaxFileTitle    dd      0
    OFNlpstrInitialDir  dd      0
    OFNlpstrTitle       dd      0
    OFNFlags            dd      0
    OFNnFileOffset      dw      0
    OFNnfileExtension   dw      0
    OFNlpstrDefExt      dd      0
    OFNlCustData        dd      0
    OFNlpfnHook         dd      0
    OFNlpTemplateName   dd      0

start:

; Get Instance Handle
;eFUNCTION get_instance
;eRETURN genret
        pushad
        push NULL
        call GetModuleHandle
        mov genret,eax
        popad
        ret

;eFUNCTION load_cursor,handle,cursorname
;eRETURN genret
        pushad
        push cursorname
        push handle
        call LoadCursor
        mov genret,eax
        popad
        ret

;eFUNCTION register_class,OScexstruct
;eRETURN genret
        pushad
        push OScexstruct
        call RegisterClassEx
        mov genret,eax
        popad
        ret
        
;ePROCEDURE show_window,handle,showflag
        pushad
        push showflag
        push handle
        call ShowWindow
        popad
        ret

;eFUNCTION get_last_error
;eRETURN genret
        pushad
        push 0        
        call GetLastError
        mov genret,eax
        popad
        ret

;eFUNCTION get_window_pos,handle
;eRETURN xpos,ypos
        pushad
        push OFFSET RECT_STRUCT
        push handle
        call GetWindowRect
        push RECTtop
        pop ypos
        push RECTleft
        pop xpos
        popad
        ret

;ePROCEDURE move_window,handle,xpos,ypos,cwidth,cheight,rpnt
        pushad
        push rpnt
        push cheight
        push cwidth
        push ypos
        push xpos
        push handle
        call MoveWindow
        popad
        ret  

;ePROCEDURE resize_window,handle,cwidth,cheight
        call get_window_pos
        mov rpnt,1
        call move_window
        ret

;ePROCEDURE set_text,handle,text$
        pushad
        push text
        push handle
        call SetWindowText
        popad
        ret

;eFUNCTION get_text,handle,text$
;eRETURN text$
;-> supply a blank string in text$ to pass
;-> the buffer address
        pushad
        push 200h ; 512 bytes should be fine       
        push text
        push handle
        call GetWindowText
        popad
        ret

;eFUNCTION get_check,handle
;eRETURN genret
        pushad
        push 0
        push 0
        push BM_GETCHECK
        push handle
        call SendMessage
        mov genret,eax
        popad
        ret

;ePROCEDURE set_check,handle,state
        pushad
        push 0
        push state
        push BM_SETCHECK
        push handle
        call PostMessage
        popad
        ret

;eFUNCTION open_dialog,filter$,thetitle$,fname$
;eRETURN szret$
        pushad
        mov OFNFlags,OFN_FLAGS
        mov OFNnFilterIndex,1
        mov OFNnMaxFile,200h
        m2m OFNlpstrFile,fname
        m2m szret,fname
        m2m OFNlpstrFilter,filter
        m2m OFNlpstrTitle,thetitle
        push OFFSET OPENFILENAME_STRUCT
        call GetOpenFileName
        test eax,eax
        jnz @F
        push OFFSET OFNhwndOwner
        pop szret
     @@:
        popad
        ret

;eFUNCTION create,exstyle,class$,ctext$,style,xpos,ypos,cwidth,cheight,parent,id,hInst
;eRETURN genret
        pushad
        push 0
        push hInst
        push id
        push parent
        push cheight
        push cwidth
        push ypos
        push xpos
        push style
        push ctext
        push class
        push exstyle
        call CreateWindowEx
        mov genret,eax
        popad
        ret

;eFUNCTION msg_box,handle,thetitle$,text$,style
;eRETURN genret
        pushad
        push style
        push thetitle
        push text
        push handle
        call MessageBox
        mov genret,eax
        popad
        ret

;eFUNCTION msg_loop
;eRETURN eu_param
        pushad
        mov call_eu,0
message_loop:
        xor eax,eax
        push eax
        push eax
        push eax
        push OFFSET MSG_STRUCT
        call GetMessage
        test eax,eax
        jz @F

        push OFFSET MSGhWnd
        call TranslateMessage

        push OFFSET MSGhWnd
        call DispatchMessage
        cmp call_eu,0
        jz message_loop
      @@:
        popad 
        ret

;eLABEL OSwndProc
WndProc PROC WPhWnd   :DWORD,
             WPuMsg   :DWORD,
             WPwParam :DWORD,
             WPlParam :DWORD
        cmp WPuMsg, WM_COMMAND
        jnz @F
        cmp WPwParam,200h
        ja  @F
        push WPwParam
        pop eu_param
        inc call_eu
        ret
      @@:
        cmp WPuMsg, WM_DESTROY
        jnz @F
        mov eu_param,0
        push NULL
        call PostQuitMessage
        xor eax,eax              
        ret                    
      @@:
        push WPlParam
        push WPwParam
        push WPuMsg
        push WPhWnd
        call DefWindowProc
        ret
WndProc ENDP

end start
